#
# Please see the COPYRIGHT_and_DISCLAIMER file in the top level
# directory of the distribution regarding the provisions under
# which this software is distributed.
#

sub getline
{
    local($_);

    @curline = ();
    if (defined($lookahead))
    {
	$_ = $lookahead;
	$l = $_;
#	print "Assigned lookahead '$l'\n";
	undef $lookahead;
    }
    else
    {
	$_ = <$InputFile>;
	$l = $_;
#	print "Read '$l'\n";
	$lineno = $.;
    }
    return undef unless defined($_);

    push(@curline, $_);
    
    $lineno = $.;
    while (defined($lookahead = <$InputFile>))
    {
#	print "Read2 lookahead $lookahead\n";
	last unless $lookahead =~ /^[cC*]/;
    }
    $lookahead =~ s/\t/        /g if defined($lookahead);
#    print "$. Got '", substr($lookahead, 5, 1), "' la '$lookahead'\n";
    while (defined($lookahead) && substr($lookahead, 5, 1) ne ' ')
    {
#	print "added continued line $lookahead\n";
	$_ .= substr($lookahead, 7);
	push(@curline, $lookahead);
	while (defined($lookahead = <$InputFile>))
	{
#	    print "Read3 lookahead $lookahead\n";
	    last unless $lookahead =~ /^[cC*]/;
	}
	last unless defined($lookahead);

	$lookahead =~ s/\t/        /g;
#	print "$. Got '", substr($lookahead, 5, 1), "' la '$lookahead'\n";
    }
#    print "$. Got line '$_'\n" if $. >0;

    $l = $lookahead;
#    print "Leaving, la='$l'\n";

    tr/\r\n//d;
    tr/\t/        /;
    grep(tr/\r\n//d, @curline);
#    print "$. Got line '$_'\n" if $. >0;
    return $_;
}

1;
