/*
 * Please see the COPYRIGHT_and_DISCLAIMER file in the top level
 * directory of the distribution regarding the provisions under
 * which this software is distributed.
 */


extern void	_y_md_init();
extern void	_y_md_reinit();
extern void	_y_md_shutdown();
extern void	_y_md_fatal(int return_code);
extern void	_y_md_exit(int return_code);
extern void	_y_md_process_arguments_init();
extern int	_y_md_process_arguments(int current_arg, int arg_count);
extern void	_y_md_usage_message();
extern int	_y_md_remote_start_args(char *buf, int size);
extern char *	_y_md_system_error_string();
extern void	_y_md_gethostname(char *name, int len);
extern void	_y_md_get_host_id(char **hostname_id, int *process_id);
extern void	_y_md_get_short_host_id(char **a_hostname_id);
extern char *	_y_md_get_username();

extern void	_y_parse_args(int  (*package_args_func)(int, int),
			      int  (*remote_start_args_func)(char *, int),
			      void (*usage_message_func)() );
extern int	_y_remote_start_args(char *buf, int size);

extern void	_y_reinit();
extern conn_t	_y_alloc_conn();
extern void	_y_add_proto(conn_t conn, yoke_proto_t a_proto);

extern void _y_tcp_dump_buffer(FILE *fp, tcp_buffer_t *buf);
extern void _y_tcp_dump_proto(FILE *fp, tcp_proto_data_t *tproto);
extern void _y_dump_proto(FILE *fp, yoke_proto_t proto);
extern void _y_dump_data_structures(FILE *fp);
extern void yoke_dump_data_structures();
extern void _y_tcp_dump_data_structures(FILE *fp);
