/*
 * Please see the COPYRIGHT_and_DISCLAIMER file in the top level
 * directory of the distribution regarding the provisions under
 * which this software is distributed.
 */


#ifdef DEBUG
#define YokeDebug(Level) (_y_debug_level >= (Level))
#endif

#ifdef MALLOC_DEBUG
#define YokeMallocDebug(Level) (_y_malloc_debug_level >= (Level))
#endif

#ifdef DEBUG
#define YokeBufferMagicCheck(func, buf) \
	if ((buf)->basic.magic != YOKE_BUFFER_MAGIC) \
	    yoke_fatal(#func ": Bad magic number %x on buffer %x\n", \
		       (buf)->basic.magic, buf);
#else
#define YokeBufferMagicCheck(func, buf)
#endif
